<?php
/**
 * Plugin Name: Flex Feature Slider
 * Plugin URI: http://www.flexsqueeze.com
 * Description: Adds feature area rotating content to FlexSqueeze and Flexibility Themes
 * Version: 1.02
 * Author: Advantus Media, Inc.
 * Author URI: http://www.flexsqueeze.com
 */

//*************** Admin function ***************



add_action('admin_menu', 'flex_slider_menu');

function flex_slider_menu() {

  add_submenu_page('themes.php', 'Flex Slider Options', 'Flex Slider', 'manage_options', 'flex_sl', 'flex_sl_options');

}

function flex_sl_options() {

  if (!current_user_can('manage_options'))  {
    wp_die( __('You do not have sufficient permissions to access this page.') );
  }
  
  $options = array (
					
	array(	"type" => "begin"),
	
	array(	"type" => "title",
		  	"title" => "Slider Loop Options",
			"descr" => "You can loop through your widgets continuously or you can show them all once and stop at the slide you specify in the 'Stop at slide #' option. The stop option is useful if, for example, you have your e-mail opt-in form in widget 3 and want to end the slide show on that slide."),
    
    array(  "id" => "flexsl_loop",
		  	"name" => "Select: ",
			"std" => "loop",
			"type" => "select",
			"options" => array ("loop", "stop")),
	
	array(  "id" => "flexsl_stopno",
		  	"name" => "Stop at slide #: ",
			"std" => "",
			"type" => "text"),
	
	array(	"type" => "break"),
	 
	array(	"type" => "begin"),
	
	array(	"type" => "title",
		  	"title" => "Slide Sync/Transition/Speed",
			"descr" => "Set Sync to 1 if you want two slides visible at the same time during transition. Set your transition and slide delay speeds (in milliseconds).<br /><br />Set the Slide delay to 0 if you do not want the slides to automatically go to the next one. This requires the user to click the prev/next buttons to advance to the next widget."),
	
	array(  "id" => "flexsl_sync",
		  	"name" => "Choose sync: ",
			"std" => "1",
			"type" => "select",
			"options" => array ("1", "0")),
	
	array(  "id" => "flexsl_trans",
		  	"name" => "Transition: ",
			"std" => "scollHorz",
			"type" => "select",
			"options" => array ("scrollHorz", "scrollVert", "fade", "blindX", "blindY", "blindZ", "cover", "toss", "uncover")),
	
	array(  "id" => "flexsl_transspeed",
		  	"name" => "Transition Speed: ",
			"std" => "300",
			"type" => "text"),
	
	array(  "id" => "flexsl_delay",
		  	"name" => "Slide delay (0 for manual transition): ",
			"std" => "4000",
			"type" => "text"),
	
	array(	"type" => "break"),
	 
	array(	"type" => "begin"),
	
	array(	"type" => "title",
		  	"title" => "Slider Navigation Settings",
			"descr" => "You can show two types of navigation for your slider, previous/next buttons and also pagination buttons for every page or widget in your slider. Select the type of navigation style you want to use for the previous/next buttons. You can position the navigation inside your feature margin or outside. Control the vertical positioning by setting the 'Top position' option. Do the same for the optional pagination navigation and choose a color for those buttons."),
	
	array(  "id" => "flexsl_shownav",
		  	"name" => "Show Prev/Next navigation?: ",
			"std" => "yes",
			"type" => "select",
			"options" => array ("yes", "no")),
	
	array(  "id" => "flexsl_nav",
		  	"name" => "Prev/Next button style: ",
			"std" => "Orange buttons",
			"type" => "select",
			"options" => array ("orange-button", "red-button", "blue-button", "green-button", "grey-button", "clear-button-inner", "clear-button-outer", "gold-arrow", "blue-arrow", "green-arrow", "red-arrow", "grey-arrow", "prev-next", "sleek-arrow", "orange-next-step", "red-next-step", "green-next-step", "blue-next-step", "red-next-step-script", "orange-next-step-script", "blue-next-step-script", "green-next-step-script")),
	
	array(  "id" => "flexsl_pos",
		  	"name" => "Top position: ",
			"std" => "250",
			"type" => "text"),
	
	array(  "id" => "flexsl_inout",
		  	"name" => "Inner or outer positioning: ",
			"std" => "outer",
			"type" => "select",
			"options" => array ("outer", "inner")),
	
	array(	"type" => "break"),
	 
	array(	"type" => "begin"),
	
	array(	"type" => "title",
		  	"title" => "Pagination Navigation Settings",
			"descr" => "Pagination navigation allows users to link directly to any of your widget slides instead of having to click the previous or next button multiple times. The navigation shows as colored dots and can be positioned left, center, or right in any vertical position."),
	
	array(  "id" => "flexsl_showpag",
		  	"name" => "Show pagination navigation?: ",
			"std" => "no",
			"type" => "select",
			"options" => array ("no", "yes")),
	
	array(  "id" => "flexsl_pagloc",
		  	"name" => "Pagination alignment: ",
			"std" => "center",
			"type" => "select",
			"options" => array ("center", "left", "right")),
	
	array(  "id" => "flexsl_pagpos",
		  	"name" => "Pagination top position: ",
			"std" => "250",
			"type" => "text"),
	
	array(  "id" => "flexsl_pagclr",
		  	"name" => "Pagination color: ",
			"std" => "white",
			"type" => "select",
			"options" => array ("white", "black", "orange", "red", "green", "blue")),
			
	
	array(	"type" => "break"),
	
	array(	"type" => "begin"),
	
	array(	"type" => "title",
		  	"title" => "Feature Area Padding Removal",
			"descr" => "If you want to remove the padding around the feature content, select 'yes' to the option below. This works well for images or content that you want to span the full width of your site."),
	
	array(  "id" => "flexsl_pad",
		  	"name" => "Remove padding?: ",
			"std" => "no",
			"type" => "select",
			"options" => array ("no", "yes")),
	
	array(	"type" => "break")
	 

		  
		  )

  ?>
  <div class="wrap">  

  <h2>Flex Slider Options</h2>
  <p>To use the feature area rotating content, insert several text widgets into the top feature area of the theme. The slider plugin will rotate through each widget using the settings below.</p>
  <p><strong>IMPORTANT!</strong> In your theme options, you must set the 'Number of columns' option in the 'Top Feature' tab to 1.</p>
  <p><a href="http://www.flexsqueeze.com/using-the-flex-slider-plugin/">Click to view tutorial</a> on how to use the Flex Slider plugin.</p>
  <?php 
  if ($_POST["action"] == "update")  
     {  
              foreach ($options as $value) {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

              foreach ($options as $value) {
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
           echo '<div class="updated"><p><strong>Options Updated</strong></p></div>';
				}
	
	
?>
  <form method="post" action=""> 
  <input type="hidden" name="action" value="update" /> 
  <p class="submit">
	<input type="submit" name="Submit" value="Update options" />
	</p>
    <?php 
  $plugin_img = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'images/';
  
  foreach ($options as $value) { 
  
  if ($value['type'] == "begin") { ?>
  <table class="form-table">
       <tr valign="top">
       <td>
  <?php } 
  
  else if ($value['type'] == "title") { ?>
  <h3><?php echo $value['title']; ?></h3>
  <p><?php echo $value['descr']; ?></p>
  
  </td>
  </tr>
  <tr><td>
  <?php } 
  
  else if ($value['type'] == "select") { ?>

        <div style="margin: 0 15px 10px 0;float:left;"><strong><?php echo $value['name']; ?></strong> <select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
            <?php foreach ($value['options'] as $option) { ?>
            <option<?php if ( get_option( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
            <?php } ?>
          </select></div>
   
      
      <?php } else if ($value['type'] == "text") { ?>
 
        <div style="margin: 0 15px 10px 0;float:left;"><strong><?php echo $value['name']; ?></strong> <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_option( $value['id'] ) != "") { echo get_option( $value['id'] ); } else { echo $value['std']; } ?>" style="width:50px;"/></div>

     
      <?php } else if ($value['type'] == "break") { ?>
      </td></tr></table>
      <?php } ?>
      <?php } ?>
      <table>
       <tr><td>
	<p class="submit">
	<input type="submit" name="Submit" value="Update options" />
	</p>
    </td></tr></table>

</form>
     
  </div>
  <?php
  
}

if (!is_admin()) {
	
$plugin_js = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'js/';
	
wp_enqueue_script('jquery-cycle', $plugin_js . 'jquery.cycle.all.min.js', array('jquery'), '');

function flexsl_head() { 
$plugin_img = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'images/';
?>


<script type="text/javascript">
jQuery(document).ready(function() {
	if (jQuery("#feature").length > 0){
	jQuery('#feature .feat_box:first-child').addClass('first');
	jQuery('#feature .topshadow').addClass('clearfix');
	jQuery('#feature .feat_box:first').fadeIn(1000, function() {
         jQuery('#feature .topshadow').cycle({
		fx: '<?php if ('flexsl_trans') { echo get_option('flexsl_trans'); } else { echo 'scrollHorz'; } ?>', 
		cleartypeNoBg: true,
		sync: <?php if ('flexsl_sync') { echo get_option('flexsl_sync'); } else { echo '1'; } ?>, 
		speed: <?php if ('flexsl_transspeed') { echo get_option('flexsl_transspeed'); } else { echo '300'; } ?>, 
		pause: true,
		<?php if ( get_option('flexsl_shownav') == 'yes' ) { ?>
		prev:   '#slideprev', 
    		next:   '#slidenext', 	
		after:   onAfter, 
		<?php } ?>
		<?php if ( get_option('flexsl_showpag') == 'yes' ) { ?>
		pager: '#pagernav',
		pagerAnchorBuilder: function(idx, slide) { 
        	return '<li><a class="pagernav" href="#"></a></li>'; 
   		},
		<?php } ?>
		<?php if (get_option('flexsl_loop') == "stop") { ?>
		autostop: 1,
		autostopCount: <?php echo get_option('flexsl_stopno'); ?>,
		<?php } ?>
		timeout: <?php if ('flexsl_delay') { echo get_option('flexsl_delay'); } else { echo '4000'; } ?> 
		
	});
    });
	<?php if ( get_option('flexsl_shownav') == 'yes' ) { ?>
	jQuery('#feature').append('<div class="slidernav"><a id="slideprev" href="#" style="display:none;"></a><a id="slidenext" href="#" style="display:none;"></a></div>');
	<?php } ?>
	<?php if ( get_option('flexsl_showpag') == 'yes' ) { ?>
	jQuery('#feature').append('<div id="pagernav"></div>');
	<?php } ?>
	jQuery('#feature .topshadow div:last').remove();
   }
});

<?php if ( get_option('flexsl_shownav') == 'yes' ) { ?>
function onAfter(curr, next, opts) {
   var index = opts.currSlide;
   	jQuery('#slideprev')[index == 0 ? 'hide' : 'show']();
    jQuery('#slidenext')[index == opts.slideCount - 1 ? 'hide' : 'show'](); 
}
<?php } ?>

</script>

<?php 
$plugin_img = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'images/';
if (get_option('flexsl_inout') == "outer") { 

$navcode = (get_option('flex_blog_width') + 100 + (get_option('flex_blog_borderwidth')*2)); 
$margin = get_option('flex_blog_borderwidth') + 50;
} else { 
$navcode =  get_option('flex_blog_width'); 
$margin = 0;
}
if (get_option('flexsl_nav') == "prev-next" || get_option('flexsl_nav') == "sleek-arrow") {
	$widheight = "width:100px;height:50px;"; }
else if (get_option('flexsl_nav') == "orange-next-step" || get_option('flexsl_nav') == "green-next-step" || get_option('flexsl_nav') == "red-next-step" || get_option('flexsl_nav') == "blue-next-step" || get_option('flexsl_nav') == "red-next-step-script" || get_option('flexsl_nav') == "orange-next-step-script" || get_option('flexsl_nav') == "blue-next-step-script" || get_option('flexsl_nav') == "green-next-step-script") {
	$widheight = "width:225px;height:60px;"; }
	else { $widheight = "width:50px;height:100px;"; }
	
if (get_option('flexsl_pad') == "yes") { 
	$padcode = '#feature{padding:0px;} #feature .topshadow, #feature .feat_box { padding:0px; margin:0px; }';
	$featboxwidth = 'width:' . get_option('flex_blog_width') . 'px;';
} else { 
	$featboxwidth = 'width:' .  (get_option('flex_blog_width') - 30 ). 'px;';
}



echo '<style type="text/css">
#feature div.topshadow {width:' . get_option('flex_blog_width') . 'px;margin:0px;padding:0px;}
.topshadow .feat_box { display: none; ' . $featboxwidth . '}
.topshadow .feat_box .first { display: block }
#pagernav {position:absolute; top:' . get_option('flexsl_pagpos') . 'px;z-index:350;width:' . (get_option('flex_blog_width')-20) . 'px;padding:0 10px;text-align:' . get_option('flexsl_pagloc') . ';}
#pagernav li {display:inline; height:20px;width:20px;}
#pagernav li a {background: transparent url(' . $plugin_img . 'page-nav-' . get_option('flexsl_pagclr') . '.png) no-repeat center;height:20px; width:20px;display:inline-block;}
#pagernav li.activeSlide a {background: transparent url(' . $plugin_img . 'page-nav-' . get_option('flexsl_pagclr') . '-active.png) no-repeat center;}
.slidernav {width:' . $navcode . 'px;height:30px;background-color:transparent;margin:0 -' . $margin .'px;position:absolute;top:' . get_option('flexsl_pos') . 'px;z-index:300;}
#slideprev {float:left;' . $widheight . ';background: url(' . $plugin_img . 'nav-left-' . get_option('flexsl_nav') . '.png) no-repeat center right;}
#slidenext {float:right;text-align:right;' . $widheight . ';background: url(' . $plugin_img . 'nav-right-' . get_option('flexsl_nav') . '.png) no-repeat center left;}
a:active, a:focus {outline:none;}
.feat_box {width:' . (get_option('flex_blog_width') - 30) . 'px;}' . $padcode . '
</style>';

} 

function loadflexslider(){
	return flexsl_head();
	}

add_action( is_admin() ? 'admin_head' : 'wp_head', 'loadflexslider' );

}
?>